---
- name: Check if MySQL is already installed.
  ansible.builtin.stat:
    path: "{{ mysql_config_fie }}"
  register: mysql_installed

  
- name: install mysql
  ansible.builtin.apt:
    name: "{{ mysql_packages }}"
    state: latest

- name: sets password
  mysql_user:
    name: root
    password: "{{ mysql_root_new_password }}"
    login_unix_socket: /var/run/mysqld/mysqld.sock
  when: not mysql_installed.stat.exists

- name: sets the root password
  mysql_user:
    name: root
    host: "{{ item }}"
    password: "{{ mysql_root_new_password }}"
    login_user: root
    login_password: "{{ mysql_root_new_password }}"
    check_implicit_admin: yes
    priv: "*.*:ALL,GRANT"
    state: present
  with_items:
    - "{{ ansible_hostname }}"
    - 127.0.0.1
    - ::1
    - localhost

- name: remove anonymous users
  mysql_user:
    login_user: root
    login_password: "{{ mysql_root_new_password }}"
    user: ""
    host_all: yes
    state: absent

- name: remove test database
  mysql_db:
    login_user: root
    login_password: "{{ mysql_root_new_password }}"
    db: test
    state: absent

- name: remove test database priviledges
  block:
    - shell: mysql -u root -p{{ mysql_root_new_password }} -e "DELETE FROM mysql.db WHERE Db='test' OR Db='test\\_%'"
    - shell: mysql -u root -p{{ mysql_root_new_password }} -e "FLUSH PRIVILEGES"

- name: "new database {{ db_name }}"
  mysql_db:
    login_user: root
    login_password: "{{ mysql_root_new_password }}"
    name: "{{ db_name }}"
    collation: utf8_unicode_ci
    encoding: utf8
    state: present

- name: "new users {{ db_user }}"
  mysql_user:
    login_user: root
    login_password: "{{ mysql_root_new_password }}"
    name: "{{ db_user }}"
    password: "{{ db_password }}"
    priv: "{{ db_name }}.*:ALL"
    state: present

- name: Updating the config file to allow outside access
  lineinfile:
    destfile: /etc/mysql/mysql.conf.d/mysqld.cnf
    regexp: "bind-address"
    line: " "
  become: yes

- name: Updating the config file to allow outside access
  lineinfile:
    destfile: /etc/mysql/mysql.conf.d/mysqld.cnf
    regexp: "bind-address"
    line: "bind-address     =0.0.0.0"
  become: yes

- name: Updating the config file to allow data dir
  lineinfile:
    destfile: /etc/mysql/mysql.conf.d/mysqld.cnf
    regexp: "data-dir"
    line: "datadir     = {{ data_dir }}"
  become: yes

- name: Updating the config file to allow port
  lineinfile:
    destfile: /etc/mysql/mysql.conf.d/mysqld.cnf
    regexp: "port"
    line: "port            = 3306"
  become: yes

- name: "ensure mysql is enabled to run on startup"
  service:
    name: mysql
    state: restarted
    enabled: true
  become: yes
